'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.kindOf = undefined;
exports.property = property;
exports.instanceOf = instanceOf;

var _kindOf = require('kind-of');

var _kindOf2 = _interopRequireDefault(_kindOf);

var _isobject = require('isobject');

var _isobject2 = _interopRequireDefault(_isobject);

var _isPlainObject = require('is-plain-object');

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MAX_ARRAY_INDEX = Math.pow(2, 53) - 1;
var isDefined = function isDefined(v) {
  return v !== null && v !== undefined;
};
var isUndefined = function isUndefined(v) {
  return v === null || v === undefined;
};

// https://github.com/jonschlinkert/kind-of
exports.kindOf = _kindOf2.default;
function property(key) {
  return function (obj) {
    return isUndefined(obj) ? undefined : obj[key];
  };
}

function instanceOf(Cls) {
  return function (obj) {
    return obj instanceof Cls;
  };
}

// Number, Function, RegExp, Boolean, Date, Error, Arguments,
// PlainObject, Object, Array, ArrayLike, Element
var is = {
  Undefined: isUndefined,
  Defined: isDefined,
  Element: function Element(v) {
    return !!(v && v.nodeType === 1);
  },
  PlainObject: _isPlainObject2.default,
  Object: _isobject2.default
};

['Array', 'Number', 'Function', 'RegExp', 'Boolean', 'Date', 'Error', 'Arguments', 'Null', 'String'].forEach(function (name) {
  is[name] = function (v) {
    return (0, _kindOf2.default)(v) === name.toLowerCase();
  };
});

var getLength = property('length');
is.ArrayLike = function (collection) {
  var length = getLength(collection);
  return is.Number(length) && length >= 0 && length <= MAX_ARRAY_INDEX;
};

exports.default = is;