'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = middlewareFactory;

var _is = require('./is');

var _is2 = _interopRequireDefault(_is);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function middlewareFactory() {
  var _options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var getHandler = (0, _is.property)('handler');
  var isHopeAction = (0, _is.property)(_utils.HOPE_ACTION);
  return function (store) {
    return function (next) {
      return function (action) {
        if (isHopeAction(action)) {
          var handler = getHandler(action);
          (0, _utils.invariant)(_is2.default.Function(handler), 'Hope: Expecting handler of ' + action.type + ' is a function in instanceof check, but got ' + (0, _is.kindOf)(handler));
          handler(store, action);
        }
        return next(action);
      };
    };
  };
}
module.exports = exports['default'];